\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Ushi-3 test nummer A
\ DESCRIPTION : Zoek de nulstand van de motoren.
\ CATEGORY    : Applicatie, afmeting: 848 bytes.
\ AUTHOR      : Willem Ouwerkerk, Augustus 04, 2003
\ LAST CHANGE : Willem Ouwerkerk, November 23, 2003
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel
4 SET-CRYSTAL                           \ Gebruik 4 MHz kristal
NEEDS MS.FRT                            \ Laad geschikte MS versie

INCLUDE USHIO-1.FRT                     \ Laad basis Ushi-I/O routines


DOC over het opzoeken van de nulstand

De servo's zijn aangesloten op connector ST-10 en ST-11.
De RC5-ontvanger op connector ST-3 en ST-4.

Ushi staat na het opstarten stil als de juiste konstante is
geselecteerd. Als het niet zo is dan helpt dit programma 
je de goede waarden voor de konstantes STILSTAND# te vinden.
De leds op Ushi tonen de ingetelde correctie waarde.

Zodra de goede correctie(s) gevonden zijn, kunnen deze ingevuld
worden in de file USHIO-1.FRT. Als vooruit geselecteerd is
dan moeten de constantes verhoogd worden, bij achteruit verlaagd!

De functie van de cijfertoetsen op je afstandbediening:

Cijfertoets     Functie
---------------------------------------------
    1           Neer
    2           -
    3           Op
    4           Achteruit
    5           -
    6           Vooruit
    7           -
    8           -
    9           -
    0           Stop (alleen als STILSTAND# goed is)

ENDDOC


VARIABLE CORRECTIE                  \ .. factor voor STILSTAND#

\ Zoek de goede nulstand voor beide motoren.
: ZOEK-NULSTAND     ( -- )
    RCKEY DUP 1 = IF                \ Verlaag correctiefactor
        FROM CORRECTIE
        IF  DECR CORRECTIE  THEN
    THEN
    DUP 3 = IF                      \ Verhoog correctiefactor
        FROM CORRECTIE 125 U<
        IF  INCR CORRECTIE  THEN
    THEN
    FROM CORRECTIE TO TEMPO         \ Copieer factor naar snelheid
    DUP 4 = IF  ACHTERUIT  THEN     \ Correctie aftrekken
    DUP 6 = IF  VOORUIT    THEN     \ Correctie optellen
    0= IF  STOP            THEN     \ Stop...?
    ;

\ Toon CORRECTIE binair op de leds van Ushi.
: TOON              ( -- )
    FROM CORRECTIE  INVERT TO PB
    ;

:MAIN               ( -- )
    SETUP-USHI  0 SNELHEID  STOP
    -1 SETDIR PB    SET CORRECTIE
    TOON 250 MS  CLEAR CORRECTIE
    BEGIN
        TOON  ZOEK-NULSTAND
    AGAIN
    ;

                              ( Einde )
