\ RC5 afstandbediening decoder voor de belofte voor 2001, Ushi; 172 bytes.

\ here

#00 CONSTANT RCTYPE                     \ RC5 zender type
                                        \ TV = 0, CD = 20 en VCR = 5
REGISTER RCSYS                          \ Systeem databyte (8 bits)
REGISTER RCDATA                         \ Commando databyte (6 bits)
REGISTER RC#                            \ Aantal onvangen bits

\ Geef true als er een voor dit systeem geldig RC5 commando is.
FLAG RCKEY?         ( -- flag )

FLAG RCCONTROLE                         \ Eerste halve bit, voor controle
FLAG RCBIT                              \ Tweede halve bit, voor controle

CODE HERSTART       ( -- )
    R16 CLR,                            \ Stop timer-1
    TCCR0 R16 OUT,
    R16 $80 LDI,                        \ Extern-1 interrupt aan
    GIMSK R16 OUT,
    RET,
END-CODE

CODE LEES-BIT       ( -- )              \ Lees en decodeer een bit
    R16 PUSH,
    R17 PUSH,
    R17 SREG IN,
    R16 -55 LDI,         ( -56 )        \ Zet tijd tot volgende meting 880 us
    TCNT0 R16 OUT,                      \ plus 4 us looptijd = 884 us
    CLT,
    ADR ONTVANG SBIC,                   \ Lees RC5 bit
    SET,
    ADR RCBIT BLD,                      \ Bewaar voor patroon controle
    ADR RC# INC,                        \ Verhoog de bit teller
    ADR RC# 0 BST,                      \ Haal lage bit van bit-teller op
    TS IF,                              \ Verzamel elk even (tweede) bit ?

        ADR RCCONTROLE BST,             \ Controleer bit patroon....
        R16 0 BLD,                      \ Lees vorig RC5 bit naar bit 0 van R16
        ADR RCBIT SBRS,                 \ Lees actuele RC5 bit
        R16 1 ADDI,                     \ Tel de bits bij elkaar op
        R16 1 ANDI,
        ZER IF,                         \ Geldig patroon 0/1 of 1/0 opgepikt ?
                                        \ Ja, bewaar gedecodeerde bits
            CLC,                        \ Zet ontvangen bit in carry vlag
            ADR RCBIT SBRS,
            SEC,
            ADR RC# 4 SBRS,             \ Is bit teller kleiner dan 16 ?
            ADR RCSYS ROL,              \ Ja, dan is het een systeem bit ?
            ADR RCDATA ROL,             \ Nee, het is een data bit

            R16 ADR RC# MOV,            \ Alle bits zijn ontvangen
            R16 $1B CPI,
            ZER IF,                     \ als er 14 bits opgepikt zijn ?

                R16 ADR RCSYS MOV,
                R16 $1F ANDI,           \ Pik zender ID op
                R16 RCTYPE CPI,         \ Is het een het juiste type ?
                ZER IF,
                    SET,                \ Ja, commando ontvangen !
                    ADR RCKEY? BLD,
                    ' HERSTART GCALL,
                THEN,
            THEN,
        ELSE,                           \ Ongeldig patroon, stop decoder
            ' HERSTART GCALL,           \ Interrupt aan
        THEN,
    ELSE,
        ADR RCBIT BST,                  \ Vis halve bit op
        ADR RCCONTROLE BLD,             \ en bewaar
    THEN,
    SREG R17 OUT,
    R17 POP,
    R16 POP,
    RETI,
END-CODE  T0-OVERFLOW

CODE RCSTART        ( -- )              \ Flank gezien, start decoder
    R16 PUSH,
    R17 PUSH,
    R17 SREG IN,
    ADR RCKEY? BST,
    TC IF,                              \ Vorige data verwerkt ?
        R16 CLR,
        GIMSK R16 OUT,
        R16 -31 LDI,       ( -29 )      \ Zet tijd tot eerste meting, 448 us 
        TCNT0 R16 OUT,                  \ plus 8 us = 456 us
        R16 3 LDI,                      \ Prescaler = CK/64 = 62500 Hz
        TCCR0 R16 OUT,
        ADR RC# CLR,                    \ Fake half ontvangen bit,
        SET,
        ADR RCCONTROLE BLD,             \ dit fake bit is hoog !!!
    THEN,
    SREG R17 OUT,
    R17 POP,
    R16 POP,
    RETI,
END-CODE  EXTERN1

CODE SETUP-RC       ( -- )              \ Installeer decoder hardware
    R16 8 LDI,                          \ Extern-1 actief op lage flanken
    MCUCR R16 OUT,
    R16 $80 LDI,                        \ Hardware interrupt aan
    GIMSK R16 OUT,
    R16 TIMSK IN,
    R16 $02 ORI,                        \ Sta timer 0 interrupts toe
    TIMSK R16 OUT,
    CLT,                                \ Geen toets ontvangen
    ADR RCKEY? BLD,
    ADR ZEND CBI,                       \ Zender uit
    SEI,                                \ Zet interrupts aan
    RET,
END-CODE

\ Ontvang een RC5 databyte, x is een code uit de gedefinieerde
\ RC5-code commando set. Bekijk hiervoor de RC5 device documentatie.
: RCKEY             ( -- x )            \ Wacht op een commando databyte
    BEGIN  RCKEY? UNTIL                 \ Wacht
    FROM RCDATA                         \ Laat commando achter
    $3F AND                             \ De lage 6 databits zijn geldig
    CLEAR RCKEY?                        \ Sta volgend commando toe
    ;

\ here 2swap d- d.

\ Einde